/*************************************************************************************************\
Author:         Gui Manders
Company:        Husky Energy
Description:    Controller Extension for Runsheet Functionality
History:        ssd 05.17.2016 - Always show Door status regardless of if tank is confirmed.
                ssd 05.18.2016 - Fixed some bugs with the Extra Tank Information loads and
                                 changed the way to indicate whether tank is active.
                                 Made some progress on per tank flow rate requirement
                                 Fixed service work loads not being booked error.
                mz  05.18.2016 - Added logic for pre-populating RM/County on runsheet.
                ssd 05.19.2016 - Flow rate calculation per tank and related functionality.
                ssd 05.31.2016 - Fixed bug with serial numbers confirmed warning
                ssd 06.13.2016 - Fixes flowline volume calculation
                ssd 08.29.2016 - Made fixes to copy H2S values from previous runsheets
                mz: 04.05.2017 - Fixes for Runsheets taking a very long time to load
                               - updated filter queries in LoadYesterdaysRunSheets() and LoadPreviousRunSheets()
                                 methods with selected route and added method execution time logs
                                 in RefreshSelectedWell() method. [W-000699]
                mj: 04.26.2017 - Fix for not correct FlowlineVolume and FlowRate splitting on each Runsheet update
                mj: 07.2017    - LOAD REQUESTS REFACTORING: RunSheetControllerX Rebuilt
**************************************************************************************************/

public class FM_RunSheetControllerX
{
    // ********************************************************************************* //
    // ** THIS CONTROLLER EXTENSION IS USED FOR THE MAJORITY OF FLUID RUN SHEET LOGIC ** //
    // ********************************************************************************* //

    public static final Integer MAX_LOADS_PER_SHIFT_PER_PRODUCT = 10;

    ///////////////////////////
    // * FLUID OBJECT DATA * //
    ///////////////////////////
    public Map<Id, FM_Run_Sheet__c>             lYesterdayRunSheetList {get; private set;}
    private List<FM_Run_Sheet__c>               lPreviousRunSheetList {get; private set;}
    public Map<String, LoadRequestTankWrapper>  yesterdaysInformation {get; set;}

    public FM_Run_Sheet__c oRunSheet {get; private set;}
    public Integer iLineChanged {get; set;}

    public String sRunsheetId {get; private set;}
    public Boolean bIsViewMode {get; private set;}

    public Integer iTankFlowRate {get; private set;}
    public Integer iTankFlowLineVolume {get; private set;}

    public Integer iFlowRate {get; private set;}
    public Integer iFlowLineVolume {get; private set;}

    public String sCurrentTankEquipmentId {get; set;}

    //////////////////////////////////////////
    //////////////////////////////////////////

    public List<FM_Load_Request__c> loadRequestsForRunsheet {get; private set;}

    //////////////////////////////////////////
    // * CONFIGURATION & PERMISSIONS DATA * //
    //////////////////////////////////////////

    // This is used for Load Weight Configurations
    public Integer[] aLoadAmounts {get; private set;}

    // URL Parameters - Used for Dispatch View search criteria
    public String sUrlParams {get; private set;}

    public Boolean bFLOCH2S {get; set;}
    public Boolean bCanViewServiceWork {get; private set;}
    public Boolean bCanSubmitSand {get; private set;}
    public Boolean bEditFromDispatchView {get; private set;}

    // These columns no longer show up IF all related Tanks have their information filled out
    public Boolean bDisplaySerialNumberColumn {get; private set;}
    public Boolean bDisplayLowLevelColumn {get; private set;}
    public Boolean bDisplayDoorStatusColumn {get; private set;}

    ///////////////////////////////
    // * OPERATOR ON CALL DATA * //
    ///////////////////////////////

    public Operator_On_Call__c oOperatorOnCall {get; private set;}
    public Boolean bUserIsOperator {get; private set;}

    public String sOperatorOnCallFormattedDate {get; private set;}
    public String sTakeOperatorOnCall {get; set;}

    //////////////////////////
    // * H2S READING DATA * //
    //////////////////////////

    public Well_Location_H2S_Reading__c oNewReading {get; set;}
    public Well_Location_H2S_Reading__c oPreviousReading {get; private set;}

    public String sFormattedReadingTime {get; private set;}

    ////////////////////
    // * ROUTE DATA * //
    ////////////////////

    public List<SelectOption> lRouteList {get; set;}
    public Route__c oSelectedRoute {get; private set;}

    public String sRouteNum {get; set;}
    public String sRouteId {get; set;}

    private Set<Id> setRoutes;

    ///////////////////////
    // * LOCATION DATA * //
    ///////////////////////

    private Map<Id, Location__c> mapLocations;
    public List<SelectOption> lLocationList {get; set;}

    public Location__c oSelectedLocation {get; private set;}
    public Well_Event__c oSelectedLocationPvr {get; private set;}

    public String sSelectedLocationId {get; set;}
    public String sLocationType {get; set;}

    ///////////////////////
    // * FACILITY DATA * //
    ///////////////////////

    public Facility__c oSelectedFacility {get; private set;}
    public String sSelectedFacilityId {get; set;}

    //////////////////////////
    // * STUCK TRUCK DATA * //
    //////////////////////////
    public List<FM_Stuck_Truck__c> stuckTruckList {
        get {
            if(stuckTruckList == null || stuckTruckList.isEmpty()) {
                if(sSelectedLocationId != null && sSelectedLocationId != getNotSelected()) {
                    stuckTruckList = [Select Id, Name, Carrier_Unit__r.Name, Stuck_From__c
                    From FM_Stuck_Truck__c
                    Where Location__c = :sSelectedLocationId
                    And Status__c = 'Stuck'];
                } else {
                    if (sSelectedFacilityId != null && sSelectedFacilityId != getNotSelected()) {
                        if(!sSelectedFacilityId.contains(FM_Utilities.RUNSHEET_FACILITY_WELL_STRING_IDENTIFIER)) {
                            stuckTruckList = [Select Id, Name, Carrier_Unit__r.Name, Stuck_From__c
                            From FM_Stuck_Truck__c
                            Where Facility__c = :sSelectedFacilityId
                            And Status__c = 'Stuck'];
                        } else {
                            stuckTruckList = [Select Id, Name, Carrier_Unit__r.Name, Stuck_From__c
                            From FM_Stuck_Truck__c
                            Where Location__c = :sSelectedFacilityId.replace(FM_Utilities.RUNSHEET_FACILITY_WELL_STRING_IDENTIFIER, '')
                            And Status__c = 'Stuck'];
                        }
                    }
                }
            }
            System.debug('stuckTruckList: ' + stuckTruckList);
            return stuckTruckList;
        }
        private set;
    }

    ////////////////////////
    // * FAVORITES DATA * //
    ////////////////////////

    public SelectOption[] aSelectedWells {get; set;}
    public SelectOption[] aAllWells {get; set;}

    private FM_CustomWellOrder__c oCustomWellOrderData {get; set;}
    public String sSavedSelectedWells {get; set;}

    ////////////////////////////////////////////
    // * BOOKING DATA -> PRODUCED VS BOOKED * //
    ////////////////////////////////////////////

    public BookingDataWrapper oTodayBookingData {get; private set;}
    public BookingDataWrapper oYesterdayBookingData {get; private set;}

    ////////////////////////
    // * RM/COUNTY DATA * //
    ////////////////////////
    public List<SelectOption> pickvalsRM { get;set; }
    public Boolean viewOrEditRunSheet {get;set;}

    //Load weight dynamic picklist options
    public List<SelectOption> loadWeightOptions {
        get {
            List<SelectOption> options = new List<SelectOption>();
            List<Schema.PicklistEntry> ple = FM_Run_Sheet__c.Load_Weight__c.getDescribe().getPicklistValues();
            for( Schema.PicklistEntry f : ple)
            {
                options.add(new SelectOption(f.getLabel(), f.getValue()));
            }
            return options;
        }
    }

    //////////////////
    // * TANK DATA * //
    ///////////////////
    public List<TankWrapper> standardTanks {get; set;}
    public List<TankWrapper> extraTanks {get; set;}
    private List<Equipment_Tank__c> lConfirmedTanks;
    private Set<String> setSerialNumbersConfirmed = new Set<String>();
    private Boolean bIsTankWarningDisplayed = true;
    public Boolean  tankInspected = false;

    //////////////////
    // * LOAD REQUEST * //
    ///////////////////

    public FM_Load_Request__c loadRequest {get; set; }



    //////////////////////////
    // * MAIN CONSTRUCTOR * //
    //////////////////////////

    public FM_RunSheetControllerX(ApexPages.StandardController stdController)
    {
        SetConfigurationData();
        GetUrlParameters();
        InitializeNewRunsheetData();

        // Creating NEW Runsheet?
        if(this.sRunsheetId == null)
        {
            InitializeLocationData();
            BuildRouteList();
            SelectDefaultRoute();
            RetrieveConfirmedTanks();
        }
        // View OR Edit Mode
        else
        {
            RetrieveRunSheetData(this.sRunsheetId);
        }

    }

    ////////////////////////////////////////////////////////////////////
    // * SET AND INITIALIZE GLOBAL CONFIGURATION & PERMISSIONS DATA * //
    ////////////////////////////////////////////////////////////////////

    private void SetConfigurationData()
    {
        this.sTakeOperatorOnCall = '';
        this.sLocationType = 'well';
        this.sRunsheetId = ApexPages.currentPage().getParameters().get('id');
        this.bIsViewMode = (this.sRunsheetId == null || this.sRunsheetId == '') ? false : true;
        this.bEditFromDispatchView = false;
        this.viewOrEditRunSheet = false;

        this.bUserIsOperator = FM_Utilities.VerifyPermissions(UserInfo.getUserId(), FM_Utilities.FLUID_PERMISSION_SET_OPERATOR);
        this.bCanViewServiceWork = FM_Utilities.VerifyPermissions(UserInfo.getUserId(), FM_Utilities.FLUID_PERMISSION_SET_DISPATCH_STANDARD) || FM_Utilities.VerifyPermissions(UserInfo.getUserId(), FM_Utilities.FLUID_PERMISSION_SET_FLUID_ADMIN) || FM_Utilities.VerifyProfile('Standard HOG - Administrator') || FM_Utilities.VerifyProfile('System Administrator');
        this.bCanSubmitSand = FM_Utilities.VerifyPermissions(UserInfo.getUserId(), FM_Utilities.FLUID_PERMISSION_SET_OPERATOR) || FM_Utilities.VerifyPermissions(UserInfo.getUserId(), FM_Utilities.SAND_PERMISSION_SET_SAND_LEAD);

    }

    /////////////////////////////////////////////////////////////////
    // * GET URL PARAMETERS (SEARCH SETTINGS FROM DISPATCH VIEW) * //
    /////////////////////////////////////////////////////////////////

    private void GetUrlParameters()
    {
        Map<String, String> mapParameters = ApexPages.currentPage().getParameters();
        this.sUrlParams = '';

        for(String sOneParam : mapParameters.keySet())
        {
            // IGNORE NON DISPATCH-VIEW PARAMETERS IN URL
            this.sUrlParams += (sOneParam.contains('dv_')) ? sOneParam + '=' + mapParameters.get(sOneParam) + '&' : '';
            this.bEditFromDispatchView = (sOneParam.contains('dv_')) ? true : this.bEditFromDispatchView;
        }
    }

    //////////////////////////////////////
    // * INITIALIZE NEW RUNSHEET DATA * //
    //////////////////////////////////////

    private void InitializeNewRunsheetData()
    {
        this.mapLocations = new Map<Id, Location__c>();
        this.lRouteList = new list<SelectOption>();
        this.lLocationList = new list<SelectOption>();

        this.oRunSheet = new FM_Run_Sheet__c();
        this.oRunSheet.Date__c = Date.Today();

        this.standardTanks = new List<TankWrapper>();
        this.extraTanks = new List<TankWrapper>();
    }

    ///////////////////////////////////////////////////
    // * INITIALIZE ALL LOCATION AND FACILITY DATA * //
    ///////////////////////////////////////////////////

    private void InitializeLocationData()
    {
        this.lLocationList = new List<SelectOption>();
        this.sTakeOperatorOnCall = '';

        this.oSelectedLocation = null;
        this.sSelectedLocationId = getNotSelected();

        this.oSelectedFacility = null;
        this.sSelectedFacilityId = getNotSelected();
    }

    /////////////////////////////////////
    // * BUILD SELECTABLE ROUTE LIST * //
    /////////////////////////////////////

    private void BuildRouteList()
    {
        List<Equipment_Tank__c> lAllRoutes = [SELECT Equipment__r.Location__r.Route__r.Id, Equipment__r.Location__r.Route__r.Name, Equipment__c
        FROM Equipment_Tank__c
        WHERE Equipment__r.Location__r.Route__r.Fluid_Management__c = true
        AND Equipment__r.Location__r.Functional_Location_Category__c IN :FM_Utilities.RUNSHEET_FUNCTIONAL_LOCATION_CATEGORIES
        AND Equipment__r.Location__r.Status__c IN :FM_Utilities.RUNSHEET_WELL_INCLUDED_STATUSES
        AND Equipment__r.Location__r.Well_Type__c IN :FM_Utilities.RUNSHEET_WELL_TYPES];
        this.setRoutes = new Set<Id>();

        for(Equipment_Tank__c oOneRoute : lAllRoutes)
        {
            if(!this.setRoutes.contains(oOneRoute.Equipment__r.Location__r.Route__r.Id))
            {
                this.lRouteList.add(new SelectOption(oOneRoute.Equipment__r.Location__r.Route__r.Id, oOneRoute.Equipment__r.Location__r.Route__r.Name));
                this.setRoutes.add(oOneRoute.Equipment__r.Location__r.Route__r.Id);
            }
        }

        // Sort the final Route List
        this.lRouteList = FM_Utilities.SortSelectOptions(this.lRouteList, FM_Utilities.SortSelectOptionBy.Label);
    }

    /////////////////////////////////////////////////////////////////////
    // * SELECT THE DEFAULT ROUTE BASED ON PREVIOUS RUNSHEET ENTERED * //
    /////////////////////////////////////////////////////////////////////

    private void SelectDefaultRoute()
    {
        List<FM_Run_Sheet__c> lLastRunSheet = [ SELECT Id, Name, Well__r.Route__c, Well__r.Route__r.Name
        FROM FM_Run_Sheet__c
        WHERE
        Well__c != null
        AND CreatedById = :UserInfo.getUserId()
        AND Well__r.Route__c IN :this.setRoutes
        ORDER BY CreatedDate DESC
        LIMIT 1];

        if(lLastRunSheet.size() > 0)
        {
            this.sRouteId = lLastRunSheet[0].well__r.Route__c;
            this.sRouteNum = lLastRunSheet[0].well__r.Route__r.Name;

            RefreshLocationList();
        }
    }

    //////////////////////////////////////////
    // * RETRIEVE LIST OF CONFIRMED TANKS * //
    //////////////////////////////////////////

    private void RetrieveConfirmedTanks()
    {
        lConfirmedTanks = [Select Id, Name, Serial_Number__c, Serial_Number_Match__c
        From Equipment_Tank__c
        Where Serial_Number_Match__c = true];

        for(Equipment_Tank__c oTank : lConfirmedTanks) {
            setSerialNumbersConfirmed.add(oTank.Serial_Number__c);
        }
    }

    ////////////////////////////////////////////////////////////
    // * RETRIEVE RUNSHEET DATA FOR THE SPECIFIED OBJECT ID * //
    ////////////////////////////////////////////////////////////
    private void RetrieveRunSheetData(String sRunSheetId)
    {
        List<FM_Run_Sheet__c> lRunSheets = [SELECT Id, Name, CreatedDate, Is_Fluid_Facility__c, Facility__c, Well__c,
                Well__r.Unit_Configuration__c, Sour__c, Load_Weight__c, Route__c,
                Load_Weight_Amount__c, RM_County__c, Standing_Comments__c,
                Act_Flow_Rate__c, Flowline_Volume__c,
        (Select Id, Name, Label__c, Size__c, Level__c, Low_Level__c,
                Tonight_Oil__c, Tonight_Water__c, Tomorrow_Oil__c, Tomorrow_Water__c
        From Runsheet_Tank_Information__r)
        FROM FM_Run_Sheet__c
        WHERE Id = :sRunSheetId LIMIT 1];

        this.oRunSheet = (lRunSheets.size() == FM_Utilities.RUNSHEET_SINGLE_RESULT) ? lRunSheets[0] : null;

        //Initialize location/facility data
        this.sSelectedLocationId = this.oRunSheet.Well__c;
        this.sSelectedFacilityId = this.oRunSheet.Facility__c;
    }

    ///////////////////////////////
    //    * RM/COUNTY LOGIC *    //
    ///////////////////////////////
    private void PopulateRMCounty() {

        Schema.DescribeFieldResult rmValues = FM_Run_Sheet__c.RM_County__c.getDescribe();
        pickvalsRM = new list<SelectOption>();

        Set<String> rmSet = new Set<String>();

        String pickVal;
        String pickValToLowerCase;
        String rmFromSandRequest;
        String rmFromSandRequestToLowerCase;

        //pickvalsRM.add(new SelectOption('', '--None--'));
        for (Schema.Picklistentry picklistEntry : rmValues.getPicklistValues()) {
            pickvalsRM.add(new SelectOption(pickListEntry.getValue(),pickListEntry.getLabel()));
            pickVal = pickListEntry.getLabel();
            pickValToLowerCase = pickVal.toLowerCase();
            rmSet.add(pickValToLowerCase);

        }

        if (this.oSelectedLocation != null && this.sRouteId != null && !this.viewOrEditRunSheet){

            List<Route__c> smRoute = [SELECT ID, Name
            FROM Route__c
            WHERE ID = :this.sRouteId
            LIMIT 1];

            List <SM_Run_Sheet__c> smRunSheet = [SELECT ID, RM__c, Route__c, Well_Location__c, CreatedDate
            FROM SM_Run_Sheet__c
            WHERE Well_Location__c = :this.sSelectedLocationId
            AND Route__c = :smRoute[0].Name
            ORDER BY CreatedDate
                    DESC LIMIT 1 ];

            if (smRunSheet.Size() > 0 && smRunSheet[0].RM__C != null) {

                rmFromSandRequest = smRunSheet[0].RM__C;
                rmFromSandRequestToLowerCase = rmFromSandRequest.toLowerCase();

                if (rmSet.contains(rmFromSandRequestToLowerCase)) {

                    oRunSheet.RM_County__c = rmFromSandRequest.toUpperCase();

                }

            }

        }

    }


    ///////////////////////////////
    // * RETRIEVE BOOKING DATA * //
    ///////////////////////////////

    private void RetrieveBookingData()
    {
        List<FM_Run_Sheet__c> todays = [Select Id, Act_Flow_Rate__c, Flowline_Volume__c, Tonight_Oil__c, Tonight_Water__c, Tomorrow_Oil__c, Tomorrow_Water__c,
        (Select Act_Tank_Level__c, Tank_Size__c, Load_Weight_m3__c From Load_Requests__r)
        From FM_Run_Sheet__c
        Where Date__c = TODAY
        AND Well__r.Route__c = :this.sRouteId];
        Map<String, BookingDataWrapper> todaysWrapped = new Map<String, BookingDataWrapper>();
        for (FM_Run_Sheet__c runsheet : todays) {
            String key = runsheet.Id;
            todaysWrapped.put(key, new BookingDataWrapper(runsheet));
        }
        oTodayBookingData = new BookingDataWrapper(todaysWrapped);
        // System.debug(todaysWrapped.size());

        List<FM_Run_Sheet__c> yesterdays = [Select Id, Act_Flow_Rate__c, Flowline_Volume__c, Tonight_Oil__c, Tonight_Water__c, Tomorrow_Oil__c, Tomorrow_Water__c,
        (Select Act_Tank_Level__c, Tank_Size__c, Load_Weight_m3__c From Load_Requests__r)
        From FM_Run_Sheet__c
        Where Date__c = YESTERDAY
        AND Well__r.Route__c = :this.sRouteId];
        Map<String, BookingDataWrapper> yesterdaysWrapped = new Map<String, BookingDataWrapper>();
        for (FM_Run_Sheet__c runsheet : yesterdays) {
            String key = runsheet.Id;
            yesterdaysWrapped.put(key, new BookingDataWrapper(runsheet));
        }
        oYesterdayBookingData = new BookingDataWrapper(yesterdaysWrapped);
    }

    //////////////////////////////////////////////
    // * RETRIEVE WELL ORDER (FAVORITES) DATA * //
    //////////////////////////////////////////////

    private void RetrieveWellOrderData()
    {
        List<FM_CustomWellOrder__c> lWellOrderResult = [SELECT Id, WellIDList__c FROM FM_CustomWellOrder__c WHERE Route__c = :this.sRouteId AND User__c = :UserInfo.getUserId() LIMIT 1];

        this.oCustomWellOrderData = (lWellOrderResult.size() > 0) ? lWellOrderResult[0] : null;
        this.sSavedSelectedWells = (lWellOrderResult.size() > 0) ? lWellOrderResult[0].WellIDList__c : '';
    }

    //////////////////////////////////////////////////////////////////////
    // * RETRIEVE THE CURRENT OPERATOR ON CALL FOR THE SELECTED ROUTE * //
    //////////////////////////////////////////////////////////////////////

    private void RetrieveOperatorOnCallData(String sOperatorOnCallRouteId)
    {
        List<Route__c> lRouteFound = [SELECT Id, Name, Field_Senior__c FROM Route__c WHERE Id = :sOperatorOnCallRouteId];
        List<Operator_On_Call__c> lOperatorsOnCall = [SELECT Id, CreatedDate, Operator__c, Operator__r.Id, Operator__r.Name, Operator_Route__r.Field_Senior__c FROM Operator_On_Call__c WHERE Operator_Route__c = :sOperatorOnCallRouteId ORDER BY CreatedDate DESC LIMIT 1];

        this.oSelectedRoute = (lRouteFound.size() == FM_Utilities.RUNSHEET_SINGLE_RESULT) ? lRouteFound[0] : new Route__c();
        this.oOperatorOnCall = (lOperatorsOnCall.size() == FM_Utilities.RUNSHEET_SINGLE_RESULT) ? lOperatorsOnCall[0] : new Operator_On_Call__c();

        this.sOperatorOnCallFormattedDate = (lOperatorsOnCall.size() == FM_Utilities.RUNSHEET_SINGLE_RESULT) ? this.oOperatorOnCall.CreatedDate.format(FM_Utilities.RUNSHEET_DATE_FORMAT) : '';
        this.sTakeOperatorOnCall = (lOperatorsOnCall.size() == FM_Utilities.RUNSHEET_NO_RESULT && sOperatorOnCallRouteId != getNotSelected()) ? FM_Utilities.RUNSHEET_OPERATOR_ON_CALL : '';
    }

    ///////////////////////////////////////////////
    // * REDIRECT TO CUSTOMIZE WELL ORDER DATA * //
    ///////////////////////////////////////////////

    public PageReference CustomizeWellOrderRedirect()
    {
        PageReference oPage = null;

        if(this.sRouteId != FM_Utilities.RUNSHEET_VALUE_NOT_SELECTED)
        {
            oPage = Page.FM_CustomizeFluid;
            oPage.getParameters().put('route', this.sRouteNum);
        }

        return oPage;
    }

    //////////////////////////////////////////////////////////////////
    // * CLEAR THE CURRENT WELL DATA (WHEN LOCATION TYPE CHANGES) * //
    //////////////////////////////////////////////////////////////////

    public PageReference ClearWellData()
    {
        InitializeLocationData();

        this.oSelectedRoute = null;
        this.sRouteId = FM_Utilities.RUNSHEET_VALUE_NOT_SELECTED;
        this.sRouteNum = null;

        return null;
    }

    /////////////////////////////////////////////////////////////////
    // * REFRESH THE LOCATION LIST AFTER A NEW ROUTE IS SELECTED * //
    /////////////////////////////////////////////////////////////////

    public PageReference RefreshLocationList()
    {
        RetrieveBookingData();
        RetrieveWellOrderData();
        InitializeLocationData();

        if(this.sRouteId != null && this.sRouteId != getNotSelected())
        {
            RetrieveOperatorOnCallData(this.sRouteId);
            this.sRouteNum = this.oSelectedRoute.Name;
            BuildLocationLists();
        }

        return null;
    }

    ////////////////////////////////////////////////////////////////
    // * BUILD THE LIST OF LOCATIONS (ALL, FAVORITES, EXISTING) * //
    ////////////////////////////////////////////////////////////////

    private void BuildLocationLists()
    {
        Map<String, List<SelectOption>> mapLocationData = new Map<String, List<SelectOption>>();
        List<String> lSelectedWell = (this.sSavedSelectedWells != null && this.sSavedSelectedWells.trim() != '') ? sSavedSelectedWells.split(',') : new List<String>();
        Set<String> setSelectedWell = (this.sSavedSelectedWells != null && this.sSavedSelectedWells.trim() != '') ? new Set<String>(lSelectedWell) : new Set<String>();

        mapLocationData = FM_Utilities.BuildLocationMaps(lSelectedWell, setSelectedWell, this.sRouteId);
        this.mapLocations = FM_Utilities.GetLocationMap(this.sRouteId);

        Map<Id, Location__c> mapLocationsNotExistingTanks = FM_Utilities.GetLocationMapNotExistingTanks(this.sRouteId,mapLocations);
        mapLocations.putAll(mapLocationsNotExistingTanks);

        this.lLocationList = mapLocationData.get(FM_Utilities.LOCATION_INDEX_LOCATION_LIST);
        this.aAllWells = mapLocationData.get(FM_Utilities.LOCATION_INDEX_ALL_WELLS);
    }

    ///////////////////////////////////////////////////////////////////////////
    // * REFRESH THE SELECTED WELL (AFTER A NEW WELL LOCATION IS SELECTED) * //
    ///////////////////////////////////////////////////////////////////////////
    public FM_Run_Sheet__c getTodaysRunsheet() {
        List<FM_Run_Sheet__c> todaysRunsheet =  [ SELECT Id
        FROM FM_Run_Sheet__c
        WHERE
        Well__c =: sSelectedLocationId
        AND CreatedDate = TODAY
        LIMIT 1];
        return (todaysRunsheet.size() > 0) ? todaysRunsheet[0] : null;
    }

    public PageReference RefreshSelectedWell()
    {
        this.oSelectedLocation = (this.sSelectedLocationId != FM_Utilities.RUNSHEET_VALUE_NOT_SELECTED) ? mapLocations.get(this.sSelectedLocationId) : null;
        this.standardTanks = new List<TankWrapper>();
        this.extraTanks = new List<TankWrapper>();

        if(this.oSelectedLocation == null) {
            return null;
        }

        FM_Run_Sheet__c todayRS = getTodaysRunsheet();
        // if selected location has todays runsheet then redirect to this runsheet detail page
        if (getTodaysRunsheet() != null) {

            this.sRunsheetId = todayRS.Id;
            System.debug(bEditFromDispatchView);
            return GetRedirectLocation();
        }

        LoadPvrData();
        LoadRelatedTanks();
        AddExtraUnboundTanks(FM_Utilities.RUNSHEET_EXTRA_UNBOUND_TANKS);
        LoadYesterdaysRunSheets();
        LoadYesterdaysInformation();
        CopyRelevantInfoFromPreviousTanks();
        RefreshPreviousH2SReading();
        RefreshHierarchyObjects();
        PopulateRMCounty();
        return null;
    }

    //////////////////////////////////////////////////
    // * LOAD PVR DATA TO DISPLAY ON THE RUNSHEET * //
    //////////////////////////////////////////////////

    private void LoadPvrData()
    {
        List<Well_Event__c> lPvrData = [SELECT Id, PVR_AVGVOL_30D_OIL__c, PVR_AVGVOL_30D_SAND__c, PVR_AVGVOL_30D_WATER__c
        FROM Well_Event__c
        WHERE  Well_ID__c = :this.oSelectedLocation.Id
        AND Status__c = 'PROD'
        ORDER BY LastModifiedDate DESC
        LIMIT :FM_Utilities.RUNSHEET_SINGLE_RESULT];

        // NO PRODUCING EVENT --> CHECK FOR SHUT
        if(lPvrData.size() == 0)
        {

            lPvrData = [SELECT Id, PVR_AVGVOL_30D_OIL__c, PVR_AVGVOL_30D_SAND__c, PVR_AVGVOL_30D_WATER__c
            FROM Well_Event__c
            WHERE Well_ID__c = :this.oSelectedLocation.Id
            AND Status__c = 'SHUT'
            ORDER BY LastModifiedDate DESC
            LIMIT :FM_Utilities.RUNSHEET_SINGLE_RESULT];

            // NO SHUT EVENT --> CHECK FOR SUSP
            if(lPvrData.size() == 0)
            {

                lPvrData = [SELECT Id, PVR_AVGVOL_30D_OIL__c, PVR_AVGVOL_30D_SAND__c, PVR_AVGVOL_30D_WATER__c
                FROM Well_Event__c
                WHERE Well_ID__c = :this.oSelectedLocation.Id
                AND Status__c = 'SUSP'
                ORDER BY LastModifiedDate DESC
                LIMIT :FM_Utilities.RUNSHEET_SINGLE_RESULT];
            }
        }
        this.oSelectedLocationPvr = (lPvrData.size() == 1) ? lPvrData[0] : null;
    }

    ////////////////////////////////////////////////////////////////
    // * LOAD THE TANK OBJECTS RELATED TO THE SELECTED LOCATION * //
    ////////////////////////////////////////////////////////////////

    private void LoadRelatedTanks()
    {
        List<Equipment_Tank__c> lTanks = FM_Utilities.GetLocationTanks(this.oSelectedLocation.Id);

        TankWrapper oTankWrapper;

        this.bDisplaySerialNumberColumn = false;
        this.bDisplayLowLevelColumn = false;
        this.bDisplayDoorStatusColumn = false;

        Integer iCount = 1;

        for(Equipment_Tank__c oOneTank : lTanks)
        {
            // IF only 1 Tank is present and the label is blank, auto-fill it with "Tank 1"
            oOneTank.Tank_Label__c = (oOneTank.Tank_Label__c == null && lTanks.size() == FM_Utilities.RUNSHEET_SINGLE_RESULT) ? 'Tank 1' : oOneTank.Tank_Label__c;
            oTankWrapper = new TankWrapper( this.oRunSheet, this.oSelectedLocation, null, oOneTank, FM_LoadRequest_Utilities.LOADREQUEST_LOADTYPE_STANDARD, iCount++,
                    oOneTank.SCADA_Tank_Level__c, oOneTank.Low_Level__c, oOneTank.Tank_Size_m3__c,
                    null, null, null, null);
            this.standardTanks.add(oTankWrapper);

            this.bDisplaySerialNumberColumn = (oTankWrapper.bSerialNumberIsConfirmed == false) ? true : this.bDisplaySerialNumberColumn;
            this.bDisplayLowLevelColumn = (oTankWrapper.oTank.Low_Level__c == null) ? true : this.bDisplayLowLevelColumn;
            this.bDisplayDoorStatusColumn = true;
        }
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////////////////
    // * ADD EXTRA TANKS (UNBOUND TO A RECORD) TO FACILITATE BOOKING LOADS WHERE SAP DATA DOESN'T MATCH SFDC * //
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////

    private void AddExtraUnboundTanks(Integer iExtraTanks)
    {
        TankWrapper oTankWrapper;

        for(Integer iCount = 0; iCount < iExtraTanks; iCount++)
        {
            oTankWrapper = new TankWrapper( this.oRunSheet, this.oSelectedLocation, this.oSelectedFacility,
                    false, null,
                    FM_LoadRequest_Utilities.LOADREQUEST_LOADTYPE_STANDARD,
                    iCount,
                    null, null, null,
                    null, null, null, null);

            this.extraTanks.add(oTankWrapper);
        }
    }

    //////////////////////////////////////////////////////////////
    // * LOAD YESTERDAYS RUNSHEET DATA -> WELL LOCATIONS ONLY * //
    //////////////////////////////////////////////////////////////

    private void LoadYesterdaysRunSheets() {

        this.lYesterdayRunSheetList = new Map<Id, FM_Run_Sheet__c>(   [SELECT Id, Name, Load_Weight__c, Date__c, Axle__c, Standing_Comments__c, Comments_Category__c,
                Sour__c, Tank__c, Tank_Size__c, Tank_Low_Level__c, Act_Tank_Level__c, Act_Flow_Rate__c,
                Tonight_Oil__c, Tonight_Water__c, Tomorrow_Oil__c, Tomorrow_Water__c, Outstanding_Oil__c,
                Outstanding_Water__c, RM_County__c, Well__r.Route__c,
        (SELECT Label__c, Level__c, Low_Level__c, Size__c FROM Runsheet_Tank_Information__r)
        FROM FM_Run_Sheet__c
        WHERE Well__r.Route__c = :this.sRouteId      //mz: 04.05.2017
        AND Well__c = :this.oSelectedLocation.Id
        AND Date__c = YESTERDAY
        ORDER BY Tank__c]);

    }

    private void LoadYesterdaysInformation() {
        String index;

        LoadYesterdaysRunSheets();

        List<FM_Load_Request__c> yesterdaysLoadRequests = [ SELECT Name, Act_Tank_Level__c, Product__c, Shift__c, Tank_Label__c,
                Tank_Low_Level__c, Tank_Size__c, Run_Sheet_Lookup__c,
                Tank__c
        FROM
                FM_Load_Request__c
        WHERE
        Source_Location__c = : this.oSelectedLocation.Id
        AND CreatedDate = YESTERDAY];

        Map<String, LoadRequestTankWrapper> lrs = new Map<String, LoadRequestTankWrapper>();

        List<String> yestLoadRequestsRunsheetLookupIds = new List<String>();

        // loop through yesterdays LoadRequests and add them to result
        for (FM_Load_Request__c lr : yesterdaysLoadRequests) {
            index = lr.Tank_Label__c + ':' +
                    lr.Product__c + ':' +
                    lr.Shift__c + ':' +
                    lr.Act_Tank_Level__c + ':' +
                    lr.Tank_Low_Level__c + ':' +
                    lr.Tank_Size__c;

            if (lrs.size() == 0)
                lrs.put(lr.Tank_Label__c, new LoadRequestTankWrapper(index));
            else {
                if (lrs.get(lr.Tank_Label__c) == null) {
                    lrs.put(lr.Tank_Label__c, new LoadRequestTankWrapper(index));
                } else {
                    lrs.get(lr.Tank_Label__c).addLoad(index);
                }
            }


        }

        // loop through yesterdays Runsheets and if the information is not present in result map then
        // add Runsheet_TankInformation to result map
        for (FM_Run_Sheet__c rs : lYesterdayRunSheetList.values()) {
            for(FM_Runsheet_Tank_Information__c tankInformation : rs.Runsheet_Tank_Information__r) {
                if (!lrs.containsKey(tankInformation.Label__c)) {
                    index = tankInformation.Label__c + ':' +
                            tankInformation.Level__c + ':' +
                            tankInformation.Low_Level__c + ':' +
                            tankInformation.Size__c;

                    lrs.put(tankInformation.Label__c, new LoadRequestTankWrapper(index));
                }
            }
        }

        yesterdaysInformation = lrs;

    }

    public class LoadRequestTankWrapper {
        public String tankLabel {get; set;}
        public Integer tonightOil {get; set;}
        public Integer tonightWater {get; set;}
        public Integer tomorrowOil {get; set;}
        public Integer tomorrowWater {get; set;}
        public Integer tankLevel {get; set;}
        public Integer tankLowLevel {get; set;}
        public Integer tankSize {get; set;}

        public LoadRequestTankWrapper(String combination) {
            tonightOil = 0;
            tonightWater = 0;
            tomorrowOil = 0;
            tomorrowWater = 0;

            List<String> lrItems = combination.split(':');
            if (lrItems.size() == 6) {
                tankLabel = lrItems.get(0);
                if (lrItems.get(1) == 'O' && lrItems.get(2) == 'Night') tonightOil += 1;
                else if (lrItems.get(1) == 'W' && lrItems.get(2) == 'Night') tonightWater += 1;
                else if (lrItems.get(1) == 'O' && lrItems.get(2) == 'Day') tomorrowOil += 1;
                else if (lrItems.get(1) == 'W' && lrItems.get(2) == 'Day') tomorrowWater += 1;
                tankLevel = Integer.valueOf(lrItems.get(3));
                tankLowLevel = Integer.valueOf(lrItems.get(4));
                tankSize = Integer.valueOf(lrItems.get(5));
            }
            else {
                tankLabel = lrItems.get(0);
                tankLevel = Integer.valueOf(lrItems.get(1));
                tankLowLevel = Integer.valueOf(lrItems.get(2));
                tankSize = Integer.valueOf(lrItems.get(3));
            }
        }

        public void addLoad(String combination) {
            List<String> lrItems = combination.split(':');
            if (lrItems.get(1) == 'O' && lrItems.get(2) == 'Night') tonightOil += 1;
            else if (lrItems.get(1) == 'W' && lrItems.get(2) == 'Night') tonightWater += 1;
            else if (lrItems.get(1) == 'O' && lrItems.get(2) == 'Day') tomorrowOil += 1;
            else if (lrItems.get(1) == 'W' && lrItems.get(2) == 'Day') tomorrowWater += 1;
        }
    }

    /////////////////////////////////////////////////////////////////
    // * LOAD PREVIOUS RUNSHEETS DATA IF YESTERDAY NOT AVAILABLE * //
    /////////////////////////////////////////////////////////////////

    private void LoadPreviousRunSheets()
    {


        //Get the last Runsheet for this location
        this.lPreviousRunSheetList = [SELECT Id, Name, Load_Weight__c, Date__c, Axle__c, Standing_Comments__c, Comments_Category__c,
                Sour__c, Tank__c, Tank_Size__c, Tank_Low_Level__c, Act_Tank_Level__c, Act_Flow_Rate__c,
                Tonight_Oil__c, Tonight_Water__c, Tomorrow_Oil__c, Tomorrow_Water__c, Outstanding_Oil__c,
                Outstanding_Water__c, RM_County__c, Well__r.Route__c
        FROM FM_Run_Sheet__c
        WHERE Well__r.Route__c = :this.sRouteId       //mz: 04.05.2017
        AND Well__c = :this.oSelectedLocation.Id
        AND Date__c < TODAY
        ORDER BY Date__c DESC
        LIMIT 1];

    }

    ////////////////////////////////////////////////////////////
    // * Copy Relevant Information from previous run sheets * //
    ////////////////////////////////////////////////////////////

    private void CopyRelevantInfoFromPreviousTanks()
    {
        if(this.lYesterdayRunSheetList.size() > 0) {
            for(FM_Run_Sheet__c oYesterdayRunsheet : this.lYesterdayRunSheetList.values()) {
                System.debug('CopyRelevantInfoFromPreviousTanks->oYesterdayRunsheet.RM_County__c: ' + oYesterdayRunsheet.RM_County__c);
                this.oRunSheet.Load_Weight__c = (oYesterdayRunsheet.Load_Weight__c == null) ? FM_Utilities.RUNSHEET_DEFAULT_LOAD_WEIGHT : oYesterdayRunsheet.Load_Weight__c;
                this.oRunSheet.Standing_Comments__c = oYesterdayRunsheet.Standing_Comments__c;
                this.oRunSheet.Comments_Category__c = oYesterdayRunsheet.Comments_Category__c;
                this.oRunSheet.RM_County__c = oYesterdayRunsheet.RM_County__c;
                this.oRunSheet.Sour__c = oYesterdayRunsheet.Sour__c;
            }
        } else {
            LoadPreviousRunSheets();

            if(lPreviousRunSheetList.size() > 0) {
                for(FM_Run_Sheet__c oPreviousRunsheet : this.lPreviousRunSheetList) {
                    this.oRunSheet.Load_Weight__c = (oPreviousRunsheet.Load_Weight__c == null) ? FM_Utilities.RUNSHEET_DEFAULT_LOAD_WEIGHT : oPreviousRunsheet.Load_Weight__c;
                    this.oRunSheet.Standing_Comments__c = oPreviousRunsheet.Standing_Comments__c;
                    this.oRunSheet.Comments_Category__c = oPreviousRunsheet.Comments_Category__c;
                    this.oRunSheet.RM_County__c = oPreviousRunsheet.RM_County__c;
                    this.oRunSheet.Sour__c = oPreviousRunsheet.Sour__c;
                }
            }
        }
    }

    ///////////////////////////////////////////////////////////////////////////////////
    // * REFRESH THE PREVIOUS H2S READING FOR THE SELECTED LOCATION (IF IT EXISTS) * //
    ///////////////////////////////////////////////////////////////////////////////////

    private void RefreshPreviousH2SReading()
    {
        List<Well_Location_H2S_Reading__c> lPreviousReading = (this.sRunSheetId == null) ? [SELECT Id, CreatedDate, CreatedBy.Id, CreatedBy.Name, H2S_Reading__c, UOM__c, Value__c FROM Well_Location_H2S_Reading__c WHERE Well_Location__c = :this.sSelectedLocationId ORDER BY CreatedDate DESC LIMIT :FM_Utilities.RUNSHEET_SINGLE_RESULT] : [SELECT Id, CreatedDate, CreatedBy.Id, CreatedBy.Name, H2S_Reading__c, UOM__c, Value__c FROM Well_Location_H2S_Reading__c WHERE Well_Location__c = :this.oRunSheet.Well__c ORDER BY CreatedDate DESC LIMIT :FM_Utilities.RUNSHEET_SINGLE_RESULT];
        this.oNewReading = new Well_Location_H2S_Reading__c();

        this.oPreviousReading = (lPreviousReading.size() == 1) ? lPreviousReading[0] : new Well_Location_H2S_Reading__c();
        this.sFormattedReadingTime = (this.oPreviousReading.Id != null) ? this.oPreviousReading.CreatedDate.format(FM_Utilities.RUNSHEET_DATE_FORMAT_H2S) : '';

        // Thermal Wells use % everything else uses PPM
        this.oNewReading.UOM__c = (this.oPreviousReading.UOM__c != null) ? this.oPreviousReading.UOM__c : 'PPM';
        this.oNewReading.Well_Location__c = this.sSelectedLocationId;

        //We should allow user to select H2S on the form if the Well is NOT yet marked as H2S in SAP; otherwise make it readonly
        String sHazardousH2S = (this.oSelectedLocation != null) ? this.oSelectedLocation.Hazardous_H2S__c : this.oRunSheet.Well__r.Hazardous_H2S__c;
        this.bFLOCH2S = (sHazardousH2S == 'Y');
        this.oRunSheet.Sour__c = (bFLOCH2S) ? sHazardousH2S == 'Y' : this.oRunSheet.Sour__c; //Only overwrite value if Well Location is H2S
    }

    //////////////////////////////////////////////////////////////////////
    // * REFRESH THE FLOC HIERARCHY OBJECTS FOR THE SELECTED LOCATION * //
    //////////////////////////////////////////////////////////////////////

    private void RefreshHierarchyObjects()
    {
        this.oRunSheet.Operating_Field_AMU__c = this.oSelectedLocation.Operating_Field_AMU__c;
        this.oRunSheet.Operating_District__c = this.oSelectedLocation.Operating_Field_AMU__r.Operating_District__c;
        this.oRunSheet.Business_Unit__c = this.oSelectedLocation.Operating_Field_AMU__r.Operating_District__r.Business_Unit__c;

        this.oRunSheet.Axle__c = FM_Utilities.GetUnitConfigurationMapping(this.oSelectedLocation.Unit_Configuration__c);
        this.aLoadAmounts = FM_Utilities.RUNSHEET_UNITCONFIG_VOLUME_MAP.get(this.oSelectedLocation.Unit_Configuration__c);
        this.aLoadAmounts = (this.aLoadAmounts == null) ? new Integer[]{30, 30, 30} : this.aLoadAmounts;
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////////////
    // * WHEN IDENTIFYING NEW TANKS -> REFRESH DATA FOR THE SELECTED TANK LABEL AND CHECK FOR DUPLICATES * //
    /////////////////////////////////////////////////////////////////////////////////////////////////////////

    public PageReference RefreshSelectedTankLabel()
    {
        Integer iLineModified = 0;

        System.debug('RefreshSelectedTankLabel-> iLineModified: ' + iLineModified);

        // Find which line was modified
        for(Integer iCount = 0; iCount < this.standardTanks.size(); iCount++)
        {
            iLineModified = (this.standardTanks[iCount].iLineOrder == this.iLineChanged) ? iCount : iLineModified;
        }
        // Remove duplicate Tank label (if found)
        for(Integer iCount = 0; iCount < this.standardTanks.size(); iCount++)
        {
            this.standardTanks[iCount].oTank.Tank_Label__c = (iCount != iLineModified && this.standardTanks[iCount].oTank.Tank_Label__c == this.standardTanks[iLineModified].oTank.Tank_Label__c) ? '' : this.standardTanks[iCount].oTank.Tank_Label__c;
        }
        return null;
    }

    ///////////////////////////////////////
    // * REFRESH THE SELECTED FACILITY * //
    ///////////////////////////////////////

    public PageReference RefreshFacilityData()
    {
        this.standardTanks = new List<TankWrapper>();
        this.extraTanks = new List<TankWrapper>();

        //Populate Selected Facility/Location based on selecteion
        if (this.sSelectedFacilityId != null && this.sSelectedFacilityId != getNotSelected()) {
            if(!this.sSelectedFacilityId.contains(FM_Utilities.RUNSHEET_FACILITY_WELL_STRING_IDENTIFIER)) {
                List<Facility__c> facilityList = [SELECT Id, Name, Facility_Name_For_Fluid__c, Operating_Field_AMU__c,
                        Operating_Field_AMU__r.Operating_District__c,
                        Operating_Field_AMU__r.Operating_District__r.Business_Unit__c,
                        Plant_Section__r.Name
                FROM Facility__c
                WHERE Id = :this.sSelectedFacilityId
                LIMIT :FM_Utilities.RUNSHEET_SINGLE_RESULT];
                this.oSelectedFacility = (facilityList.size() == FM_Utilities.RUNSHEET_SINGLE_RESULT) ? facilityList[0] : null;
            } else {
                List<Location__c> locationList = [SELECT  Id, Name, Cost_Center__c, Senior__c, Well_Orientation__c, Current_Well_Status__c,
                        Status__c, Unit_Configuration__c, Hazardous_H2S__c, Surface_Location__c,
                        Operating_Field_AMU__c, Operating_Field_AMU__r.Operating_District__c,
                        Operating_Field_AMU__r.Operating_District__r.Business_Unit__c, Route__r.Field_Senior__r.FirstName,
                        Route__r.Field_Senior__r.LastName, Route__r.Field_Senior__r.Id, PVR_AVGVOL_5D_SAND__c, PVR_AVGVOL_30D_OIL__c,
                        PVR_AVGVOL_30D_WATER__c, PVR_AVGVOL_30D_SAND__c, Well_Type__c, Statusicon__c, Fluid_Location_Ind__c,
                        Location_Name_for_Fluid__c, Route__r.Name
                FROM Location__c
                Where Id =: this.sSelectedFacilityId.remove(FM_Utilities.RUNSHEET_FACILITY_WELL_STRING_IDENTIFIER)];
                this.oSelectedLocation = (locationList.size() == FM_Utilities.RUNSHEET_SINGLE_RESULT) ? locationList[0] : null;
            }

        }

        // Get previous Facility Runsheet (IF found) AND update Axle and set the unit config (default values for Facilities)
        this.oRunSheet = LoadPreviousFacilityRunsheet();
        this.oRunSheet.Date__c = Date.Today();
        this.aLoadAmounts = FM_Utilities.RUNSHEET_UNITCONFIG_VOLUME_MAP.get('T6X');

        // Create single Tank for the Facility
        TankWrapper oTankWrapper = new TankWrapper( this.oRunSheet, this.oSelectedLocation, this.oSelectedFacility,
                true, null,
                FM_LoadRequest_Utilities.LOADREQUEST_LOADTYPE_STANDARD,
                1,
                null, null, null,
                null, null, null, null);
        oTankWrapper.tanklabel = 'Tank 1';
        this.standardTanks.add(oTankWrapper);

        return null;
    }

    ////////////////////////////////////////////////////////////////////////////
    // * LOAD PREVIOUS FACILITY RUNSHEET (FOR SOUR) AND LOAD DEFAULT VALUES * //
    ////////////////////////////////////////////////////////////////////////////

    private FM_Run_Sheet__c LoadPreviousFacilityRunsheet()
    {
        List<FM_Run_Sheet__c> lPreviousSour = (this.sSelectedFacilityId != FM_Utilities.RUNSHEET_VALUE_NOT_SELECTED && this.sSelectedFacilityId != null &&
                !this.sSelectedFacilityId.contains(FM_Utilities.RUNSHEET_FACILITY_WELL_STRING_IDENTIFIER)) ?
                [SELECT Sour__c
                FROM FM_Run_Sheet__c
                WHERE Facility__c = :this.sSelectedFacilityId
                ORDER BY CreatedDate DESC LIMIT :FM_Utilities.RUNSHEET_SINGLE_RESULT] :
                [SELECT Sour__c
                FROM FM_Run_Sheet__c
                WHERE Well__c = :this.sSelectedFacilityId.remove(FM_Utilities.RUNSHEET_FACILITY_WELL_STRING_IDENTIFIER)
                ORDER BY CreatedDate DESC LIMIT :FM_Utilities.RUNSHEET_SINGLE_RESULT];
        FM_Run_Sheet__c oFacilityRunSheet = new FM_Run_Sheet__c(Date__c = Date.Today());

        oFacilityRunSheet.Comments_Category__c = 'Service Work';
        oFacilityRunSheet.Tank__c = 'Tank 1';

        oFacilityRunSheet.Load_Type__c = (this.oSelectedFacility.Facility_Name_For_Fluid__c == FM_Utilities.FACILITY_SAND_CAVERN_NAME) ? 'Sand Cavern' : oFacilityRunSheet.Load_Type__c;
        oFacilityRunSheet.Axle__c = FM_Utilities.FACILITY_DEFAULT_AXLE_VALUE;

        oFacilityRunSheet.Sour__c = (lPreviousSour.size() == FM_Utilities.RUNSHEET_SINGLE_RESULT) ? lPreviousSour[0].Sour__c : oFacilityRunSheet.Sour__c;
        return oFacilityRunSheet;
    }

    ////////////////////////////////////////////////////////////////////////////////////
    // * STANDARD SAVE THEN REDIRECT TO NEW SAND REQUEST WITH THE SELECTED LOCATION * //
    ////////////////////////////////////////////////////////////////////////////////////

    public PageReference SaveSand()
    {
        PageReference oSave = SaveRunsheet();
        return (oSave != null) ? new PageReference(URL.getSalesforceBaseUrl().toExternalForm() + '/apex/SM_AddRunSheet?wellid=' + this.sSelectedLocationId) : null;
    }

    //////////////////////////////////////////////////////
    // * CANCEL BUTTON REDIRECT TO RUNSHEET LIST VIEW * //
    //////////////////////////////////////////////////////

    public PageReference CancelButton()
    {
        return FM_Utilities.FluidRedirect(FM_Utilities.GetRunsheetObjectId(), true);
    }

    //////////////////////////////////////////////////
    // * SAVE THE RUNSHEET -> INSERT A NEW RECORD * //
    //////////////////////////////////////////////////
    public PageReference SaveRunsheet() {

        if(!ValidateRunSheet() || !ValidateTanks() || !SoftValidateTanks()) {
            return null;
        }

        if(sSelectedLocationId != null && sSelectedLocationId != FM_Utilities.RUNSHEET_VALUE_NOT_SELECTED) {
            oRunSheet.Well__c = (sSelectedLocationId != null && sSelectedLocationId != FM_Utilities.RUNSHEET_VALUE_NOT_SELECTED) ? sSelectedLocationId : null;
        } else if (sSelectedFacilityId != null && sSelectedFacilityId != FM_Utilities.RUNSHEET_VALUE_NOT_SELECTED){

            //if Well
            oRunsheet.Well__c = (sSelectedFacilityId.contains(FM_Utilities.RUNSHEET_FACILITY_WELL_STRING_IDENTIFIER)) ?
                    sSelectedFacilityId.remove(FM_Utilities.RUNSHEET_FACILITY_WELL_STRING_IDENTIFIER) : null;
            //if facility
            oRunsheet.Facility__c = (!sSelectedFacilityId.contains(FM_Utilities.RUNSHEET_FACILITY_WELL_STRING_IDENTIFIER)) ? sSelectedFacilityId : null;
        }


        Savepoint oSave = Database.setSavepoint();
        PageReference oPage;

        try {
            //Setting the name to comboination of location name and date
            oRunsheet.Name = ((oSelectedLocation != null) ?
                    (oSelectedLocation.Location_Name_for_Fluid__c <> null ? oSelectedLocation.Location_Name_for_Fluid__c : oSelectedLocation.Name) :
                    (oSelectedFacility.Facility_Name_for_Fluid__c <> null ? oSelectedFacility.Facility_Name_for_Fluid__c : oSelectedFacility.Name))
                    + ' - ' + Date.today().format();
            oRunSheet.Id = null;

            //Insert Tanks
            List<Equipment_Tank__c> tanksToUpdate = new List<Equipment_Tank__c>();
            for(TankWrapper st : standardTanks) {
                if(st.oTank <> null) {
                    tanksToUpdate.add(st.oTank);
                }
            }
            update tanksToUpdate;

            //Insert H2S Reading
            if(this.oNewReading.Value__c != null) {
                insert oNewReading;
            }

            this.bUserIsOperator = FM_Utilities.VerifyPermissions(UserInfo.getUserId(), FM_Utilities.FLUID_PERMISSION_SET_OPERATOR);
            InsertOperatorOnCall();

            List<FM_Runsheet_Tank_Information__c> tankInfoList = new List<FM_Runsheet_Tank_Information__c>();
            loadRequestsForRunsheet = BuildLoadRequestsInsertList(tankInfoList);
            insert oRunSheet;
            insert tankInfoList;
            insert loadRequestsForRunsheet;

            return GetRedirectLocation();

        }
        catch(DMLException e)
        {
            Database.rollback(oSave);
            String sErrorMessage = e.getMessage();

            // * ADDED BY GM 2015-08-11 * FOR ALM #440 DON'T DISPLAY UGLY EXCEPTION MESSAGE FOR VALIDATION RULE ERRORS, LET THE PAGE DISPLAY THE STANDARD MESSAGES
            if(!sErrorMessage.contains('FIELD_CUSTOM_VALIDATION_EXCEPTION'))
            {
                ApexPages.Message msg = new ApexPages.Message(Apexpages.Severity.ERROR, e.getdmlMessage(0) );
                FM_Utilities.logError(e);
            }

            return null;
        }
        catch(Exception ex)
        {
            Database.rollback(oSave);

            FM_Utilities.logError(ex);
            return null;
        }


    }

    public List<FM_Load_Request__c> BuildLoadRequestsInsertList(List<FM_Runsheet_Tank_Information__c> tankInfoList) {

        List<TankWrapper> lCombinedList = new List<TankWrapper>();
        List<FM_Load_Request__c> loadRequests = new List<FM_Load_Request__c>();

        // get default value for Load_Request__c.Create_Reason__c
        String defaultCreateReason;
        Schema.DescribeFieldResult createReasonPicklist = FM_Load_Request__c.Create_Reason__c.getDescribe();
        List <Schema.PicklistEntry> pickVals = createReasonPicklist.getPicklistValues();
        // set defaultCreateReason to first value in picklist
        // or to default selected value (if it is set)
        defaultCreateReason = pickVals[0].getValue();
        for (Schema.PicklistEntry pv: pickVals) {
            if (pv.isDefaultValue()) {
                defaultCreateReason = pv.getValue();
                break;
            }
        }

        //Getting the default carrier for the specified route.
        //Note: Assumption - For each RunSheet the route is always the same
        String routeNum = (oSelectedRoute <> null) ? oSelectedRoute.Name :
                (oSelectedFacility <> null) ? oSelectedFacility.Plant_Section__r.Name :
                        oSelectedLocation.Route__r.Name;
        System.debug('routeNum: ' + routeNum);

        List<Route__c> lRouteCarriers = [SELECT Name, Default_Carrier__c, Default_Carrier_Sour__c
        FROM Route__c
        WHERE Name =: routeNum
        AND (Default_Carrier__c != null OR Default_Carrier_Sour__c != null)
        LIMIT 1];
        //Setting the default carrier for sour and non-our loads
        //Note: Assumption - For each RunSheet the loads are either sour or not
        String defaultCarrier;
        if(lRouteCarriers != null && !lRouteCarriers.isEmpty()) {
            defaultCarrier = oRunSheet.Sour__c
                    ? ((lRouteCarriers[0].Default_Carrier_Sour__c != null)
                            ? lRouteCarriers[0].Default_Carrier_Sour__c
                            : lRouteCarriers[0].Default_Carrier__c)
                    : lRouteCarriers[0].Default_Carrier__c ;
        }

        // ADD STANDARD TANKS WRAPPERS --> LOCATIONS WITH RELATED TANKS
        for(TankWrapper oTankWrapper: this.standardTanks)
            lCombinedList.add(oTankWrapper);

        // ADD "EXTRA" WRAPPERS ---> LOCATIONS WITH MISSING TANKS
        for(TankWrapper oTankWrapper: this.extraTanks)
            // Record Selected for Insertion?
            if(oTankWrapper.bActive == true)
                lCombinedList.add(oTankWrapper);

        //Initialize loads on Runsheet
        oRunsheet.Tonight_Oil__c = 0;
        oRunsheet.Tonight_Water__c = 0;
        oRunsheet.Tomorrow_Oil__c = 0;
        oRunsheet.Tomorrow_Water__c = 0;

        // splitting the FlowlineVolume and FlowRate is performed only when Runsheets are being created
        iTankFlowLineVolume = (this.oRunSheet.Flowline_Volume__c != null) ? Integer.valueOf(this.oRunSheet.Flowline_Volume__c) : 0;
        iTankFlowRate = (this.oRunSheet.Act_Flow_Rate__c != null) ? Integer.valueOf(this.oRunSheet.Act_Flow_Rate__c) : 0;

        // create Load Request here; all data is in lCombinedList[].oTodaysRunsheet
        // loop for all products and shifts for each tank
        // check for load counts -> create LR only if load count != null && != 0
        for (TankWrapper tank : lCombinedList) {
            //Populate Tank Information
            FM_Runsheet_Tank_Information__c info = tank.getFluidTankInformation();
            info.Runsheet__r = new FM_Run_Sheet__c(Name = this.oRunSheet.Name);
            tankInfoList.add(tank.getFluidTankInformation());

            // add to insert list: OIL TONIGHT
            if (tank.tonightOil != null || tank.tonightOil != 0) {
                for (Integer i = 0; i < tank.tonightOil; i++) {
                    oRunsheet.Tonight_Oil__c++; //Update Runsheet
                    loadRequests.add(FM_LoadRequest_Utilities.createLoadRequest( oRunSheet.Name,
                            tank.loadType,
                            'O',
                            'Night',
                            'Today',
                            defaultCarrier,
                            FM_LoadRequest_Utilities.defaultAxles.get(oRunSheet.Axle__c),
                            oRunSheet.Load_Weight__c,
                            (oRunSheet.Standing_Comments__c == null) ? '' : oRunSheet.Standing_Comments__c,
                            defaultCreateReason,
                            oRunSheet.Well__c,
                            oRunSheet.Facility__c,
                            FM_LoadRequest_Utilities.LOADREQUEST_STATUS_SUBMITTED,
                            (tank.oTank == null) ? null : tank.oTank.Id,
                            (tank.oTank == null) ? tank.tankLabel : tank.oTank.Tank_Label__c,
                            tank.tankLevel,
                            (tank.oTank == null) ? tank.tankLowLevel : tank.oTank.Low_Level__c,
                            (tank.oTank == null) ? tank.tankSize : tank.oTank.Tank_Size_m3__c,
                            iTankFlowRate,
                            iTankFlowLineVolume
                    ));
                }
            }
            // add to insert list: WATER TONIGHT
            if (tank.tonightWater != null || tank.tonightWater != 0) {
                for (Integer i = 0; i < tank.tonightWater; i++) {
                    oRunsheet.Tonight_Water__c++;
                    loadRequests.add(FM_LoadRequest_Utilities.createLoadRequest( oRunSheet.Name,
                            tank.loadType,
                            'W',
                            'Night',
                            'Today',
                            defaultCarrier,
                            FM_LoadRequest_Utilities.defaultAxles.get(oRunSheet.Axle__c),
                            oRunSheet.Load_Weight__c,
                            (oRunSheet.Standing_Comments__c == null) ? '' : oRunSheet.Standing_Comments__c,
                            defaultCreateReason,
                            oRunSheet.Well__c,
                            oRunSheet.Facility__c,
                            FM_LoadRequest_Utilities.LOADREQUEST_STATUS_SUBMITTED,
                            (tank.oTank == null) ? null : tank.oTank.Id,
                            (tank.oTank == null) ? tank.tankLabel : tank.oTank.Tank_Label__c,
                            tank.tankLevel,
                            (tank.oTank == null) ? tank.tankLowLevel : tank.oTank.Low_Level__c,
                            (tank.oTank == null) ? tank.tankSize : tank.oTank.Tank_Size_m3__c,
                            iTankFlowRate,
                            iTankFlowLineVolume
                    ));
                }
            }
            // add to insert list: OIL TOMORROW
            if (tank.tomorrowOil != null || tank.tomorrowOil != 0) {
                for (Integer i = 0; i < tank.tomorrowOil; i++) {
                    oRunsheet.Tomorrow_Oil__c++;
                    loadRequests.add(FM_LoadRequest_Utilities.createLoadRequest( oRunSheet.Name,
                            tank.loadType,
                            'O',
                            'Day',
                            'Tomorrow',
                            defaultCarrier,
                            FM_LoadRequest_Utilities.defaultAxles.get(oRunSheet.Axle__c),
                            oRunSheet.Load_Weight__c,
                            (oRunSheet.Standing_Comments__c == null) ? '' : oRunSheet.Standing_Comments__c,
                            defaultCreateReason,
                            oRunSheet.Well__c,
                            oRunSheet.Facility__c,
                            FM_LoadRequest_Utilities.LOADREQUEST_STATUS_SUBMITTED,
                            (tank.oTank == null) ? null : tank.oTank.Id,
                            (tank.oTank == null) ? tank.tankLabel : tank.oTank.Tank_Label__c,
                            tank.tankLevel,
                            (tank.oTank == null) ? tank.tankLowLevel : tank.oTank.Low_Level__c,
                            (tank.oTank == null) ? tank.tankSize : tank.oTank.Tank_Size_m3__c,
                            iTankFlowRate,
                            iTankFlowLineVolume
                    ));
                }
            }
            // add to insert list: WATER TOMORROW
            if (tank.tomorrowWater != null || tank.tomorrowWater != 0) {
                for (Integer i = 0; i < tank.tomorrowWater; i++) {
                    oRunsheet.Tomorrow_Water__c++;
                    loadRequests.add(FM_LoadRequest_Utilities.createLoadRequest( oRunSheet.Name,
                            tank.loadType,
                            'W',
                            'Day',
                            'Tomorrow',
                            defaultCarrier,
                            FM_LoadRequest_Utilities.defaultAxles.get(oRunSheet.Axle__c),
                            oRunSheet.Load_Weight__c,
                            (oRunSheet.Standing_Comments__c == null) ? '' : oRunSheet.Standing_Comments__c,
                            defaultCreateReason,
                            oRunSheet.Well__c,
                            oRunSheet.Facility__c,
                            FM_LoadRequest_Utilities.LOADREQUEST_STATUS_SUBMITTED,
                            (tank.oTank == null) ? null : tank.oTank.Id,
                            (tank.oTank == null) ? tank.tankLabel : tank.oTank.Tank_Label__c,
                            tank.tankLevel,
                            (tank.oTank == null) ? tank.tankLowLevel : tank.oTank.Low_Level__c,
                            (tank.oTank == null) ? tank.tankSize : tank.oTank.Tank_Size_m3__c,
                            iTankFlowRate,
                            iTankFlowLineVolume
                    ));
                }
            }
        }

        return loadRequests;
    }

    //////////////////////////////////////////////////////
    // * INSERT OPERATOR ON CALL RECORD (IF SELECTED) * //
    //////////////////////////////////////////////////////

    private void InsertOperatorOnCall()
    {
        // Operator has marked that they wish to take ownership of the Route -> insert OOC record
        if(this.bUserIsOperator == true && this.sTakeOperatorOnCall == 'ooc')
        {
            Operator_On_Call__c oNewOperator = new Operator_On_Call__c();
            Route__c oUpdateRoute = new Route__c();

            if(this.bUserIsOperator == true)
            {
                oNewOperator.Operator__c = UserInfo.getUserId();
                oNewOperator.Operator_Route__c = this.sRouteId;
                insert oNewOperator;

                oUpdateRoute.Id = this.sRouteId;
                oUpdateRoute.Operator_On_Call__c = oNewOperator.Id;
                update oUpdateRoute;
            }
        }
    }

    ///////////////////////////////////////
    // * CONDITION-BASED PAGE REDIRECT * //
    ///////////////////////////////////////

    public PageReference GetRedirectLocation()
    {
        PageReference oPage;

        // New Run Sheet -> Reload Page
        if(this.sRunsheetId == null)
        {
            InitializeNewRunsheetData();
            oPage = Page.FM_AddRunSheet;
            oPage.setRedirect(true);
        }
        // Standard Edit -> Redirect to View Mode
        else if(bEditFromDispatchView == false)
        {
            oPage = Page.FM_ViewRunSheet;
            oPage.getParameters().put('id', this.sRunsheetId);
            oPage.setRedirect(true);
        }
        // Clicked Cancel OR Saved from Dispatch View -> Redirect back with search parameters in URL
        else
        {
            oPage = FM_Utilities.FluidRedirect('apex/FM_DispatchView?' + this.sUrlParams, true);
        }

        return oPage;
    }

    /////////////////////////////////////////////
    // * VALIDATE THE RUNSHEET BEFORE SAVING * //
    /////////////////////////////////////////////

    private Boolean ValidateRunSheet()
    {
        String sErrorMessage = '';

        // IF the Well Flow Rate is NOT entered (Standard Wells ONLY), notify the user
        if(this.oSelectedLocation != null && this.sSelectedFacilityId == getNotSelected() && this.oRunSheet.Act_Flow_Rate__c == null) {
            sErrorMessage += 'Please enter the Well Flow Rate\n<br/ >';
        }

        if(sErrorMessage != '') {
            FM_Utilities.logError(sErrorMessage);
            return false;
        }

        return true;
    }

    /////////////////////////////////////////////////////////////
    // * VALIDATE EACH TANK ON ENTRY, FOR WARNING CONDITIONS * //
    /////////////////////////////////////////////////////////////

    private Boolean SoftValidateTanks()
    {
        String sWarningMessage = '';

        //Facility IS selected?
        if(this.sSelectedFacilityId != getNotSelected())
        {
            sWarningMessage += '';
        }
        else //Well Location
        {
            //Check each Tank
            for(TankWrapper standardTank :standardTanks)
            {
                if(!standardTank.bSerialNumberIsConfirmed &&
                        (standardTank.oTank != null && setSerialNumbersConfirmed.contains(standardTank.oTank.Serial_Number__c)))
                {
                    sWarningMessage += 'Serial Number entered for ' + standardTank.oTank.Tank_Label__c + ' has already been confirmed for another tank\n<br/>';
                }
            }
        }

        if(sWarningMessage != '')
        {
            sWarningMessage += '<br/>This warning will not prevent you from saving this Runsheet. Just click the \'Submit Run Sheet\' ' +
                    'or \'Submit Run Sheet With Sand Request\' button to save the runsheet and proceed.';
            FM_Utilities.logWarning(sWarningMessage);

            //To warn but not prevent them for proceeding with the run sheet
            bIsTankWarningDisplayed = !bIsTankWarningDisplayed;
            return bIsTankWarningDisplayed;
        }

        return true;
    }

    //////////////////////////////////////////
    // * VALIDATE EACH TANK BEFORE SAVING * //
    //////////////////////////////////////////

    private Boolean ValidateTanks()
    {
        Integer iTotalLoads;
        String sErrorMessage = '';

        // Facility IS Selected?
        if(this.sSelectedFacilityId != getNotSelected()) {
            // Get Tank 1 from the Facility (SHOULD ONLY BE 1 TANK)
            TankWrapper oTankWrapper = standardTanks[0];

            // Get the total number of loads
            if (oTankWrapper.tonightOil == null) {
                iTotalLoads = 0;
            } else {
                iTotalLoads =   Integer.valueOf(oTankWrapper.tonightOil)
                        +  Integer.valueOf(oTankWrapper.tonightWater)
                        +  Integer.valueOf(oTankWrapper.tomorrowOil)
                        +  Integer.valueOf(oTankWrapper.tomorrowWater);

            }
            // Facility Selected with 0 loads?
            if(oRunSheet.Is_Fluid_Facility__c == true && iTotalLoads <= 0)
            {
                sErrorMessage += 'Facilities must be booked with at least 1 service load\n<br />';
            }

            sErrorMessage += validateTankNumbers(oTankWrapper,true);
        } else { //Location
            Set<String> setTankLabelsAlreadyUsed = new Set<String>(); //Prevent multiple tanks with same label

            // Check each Tank
            for(TankWrapper oTankWrapper : standardTanks) {
                // Missing Tank Label?
                if(oTankWrapper.oTank != null && oTankWrapper.oTank.Tank_Label__c == null || oTankWrapper.oTank.Tank_Label__c == '') {
                    sErrorMessage += 'Please specify all Tank labels';
                    break;
                }
                else if (setTankLabelsAlreadyUsed.contains(oTankWrapper.oTank.Tank_Label__c)) {
                    sErrorMessage += 'Duplicate tank labels';
                    break;
                }
                else {
                    // Missing Low Level?
                    if(oTankWrapper.oTank.Low_Level__c == null) {
                        sErrorMessage += 'Please enter the Low Level for ' + oTankWrapper.oTank.Tank_Label__c + '<br/>';
                    }

                    sErrorMessage += validateTankNumbers(oTankWrapper, false);
                }

                setTankLabelsAlreadyUsed.add(oTankWrapper.oTank.Tank_Label__c);
            }

            // Check each EXTRA Tank
            for(TankWrapper oTankWrapper : extraTanks) {
                // Tank selected for Insert?
                if(oTankWrapper.bActive == true) {
                    // Missing Tank Label?
                    if(oTankWrapper.tanklabel == null) {
                        sErrorMessage += 'Please specify all Tank labels';
                        break;
                    }
                    else if (setTankLabelsAlreadyUsed.contains(oTankWrapper.tanklabel)) {
                        sErrorMessage += 'Duplicate tank labels';
                        break;
                    }
                    else {
                        sErrorMessage += validateTankNumbers(oTankWrapper, false);
                    }

                    setTankLabelsAlreadyUsed.add(oTankWrapper.tanklabel);
                }
            }
        }

        if(sErrorMessage != '') {
            FM_Utilities.logError(sErrorMessage);
            return false;
        }

        return true;
    }

    private String validateTankNumbers(TankWrapper oTankWrapper, Boolean isFacility) {
        String sErrorMessage = '';

        if(oTankWrapper.currentDoorStatus != 'Off') {
            if(!isFacility) {
                // Missing Low Level?
                if(oTankWrapper.tankLowLevel == null) {
                    sErrorMessage += 'Please enter the Low Level for ' + oTankWrapper.tanklabel + '<br/>';
                }// Decimal check of Low Level
                else if (oTankWrapper.tankLowLevel != Math.round(oTankWrapper.tankLowLevel)) {
                    sErrorMessage += 'Please enter whole number for Tank Low Level <br />';
                }
            }

            // Missing Tank Size?
            if(oTankWrapper.tankSize == null) {
                sErrorMessage += 'Please enter the Tank Size for ' + oTankWrapper.tanklabel + '<br/>';
            }// Decimal check of Tank Level
            else if (oTankWrapper.tankSize != Math.round(oTankWrapper.tankSize)) {
                sErrorMessage += 'Please enter whole number for Tank Size <br />';
            }

            // Missing Tank Level?
            if(oTankWrapper.tankLevel == null) {
                sErrorMessage += 'Please enter the Tank Level for ' + oTankWrapper.tanklabel + '<br/>';
            }// Decimal check of Tank Size
            else if (oTankWrapper.tankLevel != Math.round(oTankWrapper.tankLevel)) {
                sErrorMessage += 'Please enter whole number for Tank Level <br />';
            }

            if(oTankWrapper.tonightOil > MAX_LOADS_PER_SHIFT_PER_PRODUCT || oTankWrapper.tonightWater > MAX_LOADS_PER_SHIFT_PER_PRODUCT ||
                    oTankWrapper.tomorrowOil > MAX_LOADS_PER_SHIFT_PER_PRODUCT || oTankWrapper.tomorrowWater > MAX_LOADS_PER_SHIFT_PER_PRODUCT) {
                sErrorMessage += 'You cannot enter more than ' + MAX_LOADS_PER_SHIFT_PER_PRODUCT + ' for a given product and shift.';
            }
        }

        System.debug('Error Message: ' + sErrorMessage);
        return sErrorMessage;
    }

    /////////////////////////////////////
    // * WRAPPER CLASS FOR RUNSHEETS * //
    /////////////////////////////////////

    public class TankWrapper {
        public FM_Run_Sheet__c oRunSheet {get; set;}
        public Equipment_Tank__c oTank {get; set;}
        public FM_Runsheet_Tank_Information__c fluidTankInformation {get; set;}

        public List<SelectOption> lServiceTypes {get; private set;}
        public Integer iLineOrder {get; private set;}
        public Boolean bSerialNumberIsConfirmed {get; private set;}
        public Boolean bDoorStatusIsConfirmed {get; private set;}
        public Date temporaryDate {get; set;}

        public Boolean bActive {get; set;} //For Extra Tank Informations to be editable or not

        public String initialDoorStatus {get; set;}
        public boolean displayPopup {get; set;}
        public String currentDoorStatus {get; set;}
        public Date inspectedDate {get; set;}

        public Integer tonightOil {get; set;}
        public Integer tonightWater {get; set;}
        public Integer tomorrowOil {get; set;}
        public Integer tomorrowWater {get; set;}

        public Decimal tankLevel {get; set; }
        public Decimal tankLowLevel {
            get;
            set{
                tankLowLevel = value;
                if(this.oTank != null)
                    this.oTank.Low_Level__c = value;
            }
        }
        public Decimal tankSize {
            get;
            set{
                tankSize = value;
                if(this.oTank != null)
                    this.oTank.Tank_Size_m3__c = value;
            }
        }

        public String LoadType {get; set;}

        public String tanklabel {get; set;}

        //////////////////////////
        // * MAIN CONSTRUCTOR * //
        //////////////////////////
        public TankWrapper( FM_Run_Sheet__c oRunsheet, Location__c oLocation, Facility__c oFacility,
                Equipment_Tank__c oOneTank, String loadType, Integer iLineNumber,
                Decimal tankLevel, Decimal tankLowLevel, Decimal tankSize,
                Integer tonightOil, Integer tonightWater, Integer tomorrowOil, Integer tomorrowWater) {

            this.lServiceTypes = FM_Utilities.GetServiceTypes(oLocation, oFacility);
            this.iLineOrder = iLineNumber;

            if(oOneTank != null) {
                this.oRunSheet = oRunsheet;
                this.oTank = oOneTank;
                this.oTank.Tank_Label__c = (this.oTank.Tank_Label__c == null) ? '' : this.oTank.Tank_Label__c;
                this.bSerialNumberIsConfirmed = !(this.oTank.Serial_Number__c == '' || this.oTank.Serial_Number__c == null);
                this.bDoorStatusIsConfirmed = !(this.oTank.Door_Status__c == '' || this.oTank.Door_Status__c == null);
                this.oTank.Serial_Number__c = this.oTank.Equipment__r.Manufacturer_Serial_No__c;
                this.initialDoorStatus = (this.oTank.Door_Status__c == null) ? '' : this.oTank.Door_Status__c;
                this.currentDoorStatus = (this.initialDoorStatus == null) ? '' : this.initialDoorStatus;
                this.tonightOil = tonightOil;
                this.tonightWater = tonightWater;
                this.tomorrowOil = tomorrowOil;
                this.tomorrowWater = tomorrowWater;
                this.tankLevel = (tankLevel == null) ? tankLevel : Math.round(tankLevel);
                this.tankLowLevel = (tankLowLevel == null) ? tankLowLevel : Math.round(tankLowLevel);
                this.tankSize = (tankSize == null) ? tankSize : Math.round(tankSize);
                this.loadType = loadType;
            }

            this.bActive = true; // default to true for
        }

        public TankWrapper( FM_Run_Sheet__c oRunsheet, Location__c oLocation, Facility__c oFacility,
                Boolean bActive, Equipment_Tank__c oOneTank, String loadType, Integer iLineNumber,
                Decimal tankLevel, Decimal tankLowLevel, Decimal tankSize,
                Integer tonightOil, Integer tonightWater, Integer tomorrowOil, Integer tomorrowWater) {

            this(   oRunsheet, oLocation, oFacility,
                    oOneTank, loadType, iLineNumber,
                    tankLevel, tankLowLevel, tankSize,
                    tonightOil, tonightWater, tomorrowOil, tomorrowWater);
            this.bActive = bActive;
        }

        ///////////////////////////////////////////////////////////////////
        // * DETERMINES IF A TANK IS EDITABLE BASED ON NUMBER OF LOADS * //
        ///////////////////////////////////////////////////////////////////

        public Boolean getTankIsEditable() {
            return (this.oRunsheet.Total_Loads__c == null || this.oRunsheet.Total_Loads__c == 0);
        }

        public PageReference startPopup() {
            if (this.currentDoorStatus == 'On') {
                displayPopup = true;
            } else {
                oTank.Door_Status__c = currentDoorStatus;
            }
            return null;
        }

        public PageReference stopPopup() {
            displayPopup = false;
            return null;
        }

        public PageReference stopPopupOk() {
            displayPopup = false;
            if(oTank <> null && currentDoorStatus <> null) {
                oTank.Door_Status__c = currentDoorStatus;
                //if (temporaryDate <> null) oTank.Last_Inspection_Date__c = temporaryDate;
            }
            return null;
        }

        public FM_Runsheet_Tank_Information__c getFluidTankInformation() {
            if(fluidTankInformation == null) {
                fluidTankInformation = new FM_Runsheet_Tank_Information__c(
                        Label__c = String.isBlank(this.tanklabel) ? this.oTank.Tank_Label__c : this.tanklabel,
                        Size__c = this.tankSize == null ? 0 : this.tankSize,
                        Low_Level__c = this.tankLowLevel == null ? 0 : this.tankLowLevel,
                        Level__c = this.tankLevel == null ? 0 : this.tankLevel,
                        Tonight_Oil__c = this.tonightOil == null ? 0 : this.tonightOil,
                        Tonight_Water__c = this.tonightWater == null ? 0 : this.tonightWater,
                        Tomorrow_Oil__c = this.tomorrowOil == null ? 0 : this.tomorrowOil,
                        Tomorrow_Water__c = this.tomorrowWater == null ? 0 : this.tomorrowWater
                );
            }
            return fluidTankInformation;
        }
    }

    public class BookingDataWrapper {
        public Decimal dProduction {get; private set;}
        public Decimal dFlowlineVolume {get; private set;}
        public Decimal dFluidBooked {get; private set;}
        public Decimal dTankInventory {get; private set;}
        public Decimal dTankLevel {get; private set;}
        public Decimal dTankInventoryPercent {get; private set;}
        public Decimal dBookedVsProductionPercent {get; private set;}

        public BookingDataWrapper(FM_Run_Sheet__c runsheet) {
            if(runsheet != null) {
                dProduction = (runsheet.Act_Flow_Rate__c != null ? runsheet.Act_Flow_Rate__c : 0);
                dFlowlineVolume = (runsheet.Flowline_Volume__c != null ? runsheet.Flowline_Volume__c : 0);
                dFluidBooked = 0;
                dTankLevel = 0;
                dTankInventory = 0;

                for(FM_Load_Request__c lr : runsheet.Load_Requests__r) {
                    dFluidBooked += (lr.Load_Weight_m3__c != null ? lr.Load_Weight_m3__c : 0);
                    dTankLevel += (lr.Act_Tank_Level__c != null ? lr.Act_Tank_Level__c : 0);
                    dTankInventory += (lr.Tank_Size__c != null ? lr.Tank_Size__c : 0);
                }
            }
        }

        public BookingDataWrapper(Map<String, BookingDataWrapper> wrapped) {
            this.dProduction = 0;
            this.dFlowlineVolume = 0;
            this.dFluidBooked = 0;
            this.dTankInventory = 0;
            this.dTankLevel = 0;
            this.dTankInventoryPercent = 0;
            this.dBookedVsProductionPercent = 0;
            for (BookingDataWrapper wrappedItem : wrapped.values()) {
                this.dProduction += (wrappedItem.dProduction != null ? wrappedItem.dProduction : 0);
                this.dFlowlineVolume += (wrappedItem.dFlowlineVolume != null ? wrappedItem.dFlowlineVolume : 0);
                this.dFluidBooked += (wrappedItem.dFluidBooked != null ? wrappedItem.dFluidBooked : 0);
                this.dTankInventory += (wrappedItem.dTankInventory != null ? wrappedItem.dTankInventory : 0);
                this.dTankLevel += (wrappedItem.dTankLevel != null ? wrappedItem.dTankLevel : 0);
            }
            this.dTankInventoryPercent = (this.dTankInventory != null && this.dTankInventory != 0) ? (this.dTankLevel / this.dTankInventory) : this.dTankInventoryPercent;
            this.dBookedVsProductionPercent = (this.dProduction != null && this.dFlowlineVolume != null && this.dProduction - this.dFlowlineVolume != 0) ? (this.dFluidBooked / (this.dProduction - this.dFlowlineVolume)) : this.dBookedVsProductionPercent;
        }

        public void addWeight(Decimal weight) {
            dFluidBooked = (dFluidBooked != null ? dFluidBooked : 0) + (weight != null ? weight : 0);
        }

    }

    /////////////////////////////////////////////////////////////////
    // * SELECT OPTION LIST FOR THE H2S READING UNITS OF MEASURE * //
    /////////////////////////////////////////////////////////////////

    public List<SelectOption> lH2SUnitOfMeasure
    {
        get
        {
            if(lH2SUnitOfMeasure == null)
            {
                lH2SUnitOfMeasure = new List<SelectOption>();
                Schema.DescribeFieldResult oResult = Schema.sObjectType.Well_Location_H2S_Reading__c.fields.UOM__c;
                List<Schema.PicklistEntry> lEntries = oResult.getPicklistValues();

                for(Schema.PicklistEntry oOneEntry : lEntries)
                {
                    lH2SUnitOfMeasure.add(new SelectOption(oOneEntry.getValue(), oOneEntry.getLabel()));
                }
            }

            return lH2SUnitOfMeasure;
        }

        private set;
    }

    /////////////////////////////////////////////////////////////////
    // * SELECT OPTION LIST FOR TANK LABELS FROM THE TANK OBJECT * //
    /////////////////////////////////////////////////////////////////

    public List<SelectOption> lTankLabels
    {
        get
        {
            String sourceType = (oSelectedLocation == null) ? 'facility' : 'location';
            if(lTankLabels == null)
            {
                lTankLabels = FM_Utilities.GetTankLabels(sourceType);
            }
            return lTankLabels;
        }

        private set;
    }

    //////////////////////////////////////////////////////////////////////////////////////////////////////////////
    // * SELECT OPTION LIST FOR THE FACILITY PICKLIST -> THIS IS A MIX OF FACILITY OBJECTS AND WELL LOCATIONS * //
    //////////////////////////////////////////////////////////////////////////////////////////////////////////////

    public List<SelectOption> lFacilityList
    {
        get
        {
            if(lFacilityList == null)
            {
                lFacilityList = FM_Utilities.GetRunsheetFacilityList();
            }

            return lFacilityList;
        }

        private set;
    }

    ////////////////////////////////////////////////////
    // * GETTER FUNCTIONS FOR VISUALFORCE REFERENCE * //
    ////////////////////////////////////////////////////

    public static String getNotSelected()
    {
        return FM_Utilities.RUNSHEET_VALUE_NOT_SELECTED;
    }

    public static String getOperatorOnCallString()
    {
        return FM_Utilities.RUNSHEET_OPERATOR_ON_CALL;
    }

    public Integer getLocationListSize()
    {
        return this.lLocationList.size();
    }

    ///////////////////////////////////////////////
    // * METHOD LOADING PREVIOUS LOAD REQUESTS * //
    ///////////////////////////////////////////////

    public List<FM_Load_Request__c> getIncompleteLoadRequests() {
        List<FM_Load_Request__c> loadrequests = new List<FM_Load_Request__c>();

        if(sSelectedLocationId != null && sSelectedLocationId != getNotSelected()) {
            loadRequests = [SELECT
                    Id, Name, Standing_Comments__c, Load_Type__c, Product__c, Shift__c, Status__c, Cancel_Reason__c,
                    Tank_Label__c, CreatedDate, CreatedBy.Name
            FROM
                    FM_Load_Request__c
            WHERE
            CreatedDate = LAST_N_DAYS:30
            AND Source_Location__c =: sSelectedLocationId
            ORDER BY
                    CreatedDate DESC
            LIMIT 30];
        } else if (sSelectedFacilityId != null && sSelectedFacilityId != getNotSelected()) {
            if(!sSelectedFacilityId.contains(FM_Utilities.RUNSHEET_FACILITY_WELL_STRING_IDENTIFIER)) {
                loadRequests = [SELECT
                        Id, Name, Standing_Comments__c, Load_Type__c, Product__c, Shift__c, Status__c, Cancel_Reason__c,
                        Tank_Label__c, CreatedDate, CreatedBy.Name
                FROM
                        FM_Load_Request__c
                WHERE
                CreatedDate = LAST_N_DAYS:30
                AND Source_Facility__c =: sSelectedFacilityId
                ORDER BY
                        CreatedDate DESC
                LIMIT 30];
            } else {
                loadRequests = [    SELECT
                        Id, Name, Standing_Comments__c, Load_Type__c, Product__c, Shift__c, Status__c, Cancel_Reason__c,
                        Tank_Label__c, CreatedDate, CreatedBy.Name
                FROM
                        FM_Load_Request__c
                WHERE
                CreatedDate = LAST_N_DAYS:30
                AND Source_Location__c =: sSelectedFacilityId.remove(FM_Utilities.RUNSHEET_FACILITY_WELL_STRING_IDENTIFIER)
                ORDER BY
                        CreatedDate DESC
                LIMIT 30];
            }
        }


        return loadRequests;
    }

    public Integer getYesterdaysInformationSize() {
        return (this.yesterdaysInformation == null) ? 0 : this.yesterdaysInformation.size();
    }
}